#include <iostream>
#include <fstream>
#include <string>
#include <iomanip>
#include <ctime>
#include "Functions.h"
#include "Game.h"
#include "Player.h"

Game::Game()
{	//Used in order 
	choice = 0;
	status = true;
	activePlayer = 0;
}

Game::~Game()
{

}

void Game::initGame()
{	
	NewPlayer();
}
//Functions
void Game::MainMenu()
{	//The Main menu presented as a set of options through a switch case statement.
	std::cout << "Please Choose one of the options below: " << std::endl;
	std::cout << std::endl;
	std::cout << "1: Play" << std::endl;
	std::cout<< "2: CheckPoint" << std::endl;
	std::cout << "3: Player" << std::endl;
	std::cout << "4: Instructions and How to Play" << std::endl;
	std::cout << "5: New Character" << std::endl;
	std::cout << "6: Save Character" << std::endl;
	std::cout << "7: Load Character" << std::endl;
	std::cout << "0: Quit" << std::endl;
	std::cout << std::endl;
	std::cout << "Choice: ";
	std::cin >> choice;

	switch (choice)
	{

	case 1:
		std::cout << std::endl;
		std::cout << "Lets Play!" << std::endl;
		std::cout << std::endl;
		break;
	case 2:
		std::cout << std::endl;
		std::cout << "Checking Last saved Checkpoint..." << std::endl;
		std::cout << std::endl;
		break;
	case 3:
		std::cout << std::endl;
		character[activePlayer].PrintToScreen();
		std::cout << std::endl;
		break;
	case 4:
		std::cout << std::endl;
		std::cout << "Here are the Instructions" << std::endl;
		std::cout << "Your Player is assigned a set of values affecting gameplay. These are: Power, Range and Ammo.\nThe different attributes will increase as you equip new weapons gained from raids and chests within the levels.\nAim of the game is to finish all of the levels within without dying and kill all of the remaining alien enemies"<< std::endl;
		std::cout << std::endl;
		break;
	case 5:
		NewPlayer();
		break;
	case 6:
		SavePlayer();
		break;
	case 0:
		status = false;
		break;
	default:
		break;
	}
}


void Game::NewPlayer()
{
	string Name = "";
	std::cout << "Welcome Uknown Player!" << std::endl;
	std::cout << "State Your Name" << std::endl;
	std::cout << "Enter: ";
	cin.ignore();
	getline(cin, Name);
	character.push_back(PlayerEvolution());
	activePlayer = character.size()-1;
	character[activePlayer].initialize(Name);
	std::cout << "Welcome!" << std::endl;
}

void Game::LoadPlayer()
{
	ifstream inFile("Character.txt");
	if (!inFile)
	{
		exit(1);
	}
	if (inFile.is_open())
	{
		varName;
	}
}

void Game::SavePlayer()
{
	ofstream outFile("Character.txt", ios_base::app);
	if (outFile.is_open())
	{
		for (size_t i = 0; i < character.size(); i++)
		{
			outFile << character[i].getAsString() << "\n";
		}
	}

	outFile.close();
}